unit KeyboardLock;

{******************************************************************************}
{*											PharmaWeb Application client													 *}
{*									Module de gestion des Locks Clavier												 *}
{*										CopyRight ApoLink S.A. 1998															 *}
{******************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

  TKeyType = (ktCapsLock,
  				ktNumLock,
               ktScrollLock);

  TKeyboardLock = class(TComponent)
  private
  protected
  public

   function GetKeyCodeState(KeyCode: TKeyType): boolean;

  	procedure ToggleCapsLock;
   procedure ToggleNumLock;
   procedure ToggleScrollLock;


  	constructor Create(AOwner: TComponent); override;

  published
  end;

procedure Register;

{$R *.RES}

implementation

function TKeyboardLock.GetKeyCodeState(KeyCode: TKeyType): boolean;
begin
	case KeyCode of
   	ktCapsLock:
       begin
       	if GetKeyState(VK_CAPITAL) = 0 then
           begin
           	Result:= false;
           end else begin
           	Result:= true;
           end;
       end;
       ktNumLock:
       begin
       	if GetKeyState(VK_NUMLOCK) = 0 then
           begin
           	Result:= false;
           end else begin
           	Result:= true;
           end;
       end;
       ktScrollLock:
       begin
       	if GetKeyState(VK_SCROLL) = 0 then
           begin
           	Result:= false;
           end else begin
           	Result:= true;
           end;
       end;
   end;
end;

procedure TKeyboardLock.ToggleCapsLock;
var
	KeyboardState: TKeyboardState;
	Scan: integer;
begin
	GetKeyboardState(KeyboardState);
  	KeyboardState[VK_CAPITAL]:= KeyboardState[VK_CAPITAL] xor 1;
  	SetKeyboardState(KeyboardState);
  	Scan:= MapVirtualKey(VK_CAPITAL, 0);
  	keybd_event(VK_CAPITAL, Scan, 0, 0);
  	keybd_event(VK_CAPITAL, Scan, KEYEVENTF_KEYUP, 0);
end;

procedure TKeyboardLock.ToggleNumLock;
var
	KeyboardState: TKeyboardState;
	Scan: integer;
begin
	GetKeyboardState(KeyboardState);
  	KeyboardState[VK_NUMLOCK]:= KeyboardState[VK_NUMLOCK] xor 1;
  	SetKeyboardState(KeyboardState);
  	Scan:= MapVirtualKey(VK_NUMLOCK, 0);
  	keybd_event(VK_NUMLOCK, Scan, 0, 0);
  	keybd_event(VK_NUMLOCK, Scan, KEYEVENTF_KEYUP, 0);
end;

procedure TKeyboardLock.ToggleScrollLock;
var
	KeyboardState: TKeyboardState;
	Scan: integer;
begin
	GetKeyboardState(KeyboardState);
  	KeyboardState[VK_SCROLL]:= KeyboardState[VK_SCROLL] xor 1;
  	SetKeyboardState(KeyboardState);
  	Scan:= MapVirtualKey(VK_SCROLL, 0);
  	keybd_event(VK_SCROLL, Scan, 0, 0);
  	keybd_event(VK_SCROLL, Scan, KEYEVENTF_KEYUP, 0);
end;

// Constructeur de l'objet TKeyboardLock.
constructor TKeyboardLock.Create(AOwner: TComponent);
begin
	inherited;
end;

procedure Register;
begin
  RegisterComponents('PharmaWeb', [TKeyboardLock]);
end;

end.
